entry _start
_start:
;--------------------------------------------------------------------------
;  ,      
;--------------------------------------------------------------------------
  cli                             ;  
  xor     ax,ax                   ;  
  mov     ss,ax                   ; :
  mov     sp,#0x7C00              ; ax = 0
  mov     si,sp                   ; sp = 0x7C00h
  push    ax                      ; si = 0x7C00h
  pop     es                      ; es = 0
  push    ax                      ; ss = 0
  pop     ds                      ; ds = 0
  sti                             ;  
  cld                             ;  repne  
  mov     di,#0x600               ; di = 0x600
  mov     cx,#0x100               ; cx = 0x100
  repne                           ;  512   0:0x600         
  movsw                           ;    , ..  
                                  ;    mbr

  mov     ax,#_done
               ;   
  add     ax,#0x600               ;    , 
  push    ax                      ;   ,
  ret                             ;     (0x600 + _done)

;--------------------------------------------------------------------------
;       (0x600 + _done)
;  ,    ,  
;  
;--------------------------------------------------------------------------
_done:
  mov     ax,#0x0003              ;    80x25
  int     0x10                    ;      
  
  mov     ah,#1                   ;   
  mov     cx,#0x2000
  int     0x10
  
  mov     si,#msg_hello + 0x600
   ;    
  call    show_str
  
press_key:
  mov     ah,#0                   ;    
  int     0x16                    ;    
  cmp     ah,#0x39                ;  - 
?
  je      load_mbr                ;  ,    
  jmp     press_key
               ; , ģ  
  
;--------------------------------------------------------------------------
;   mbr ֣  (master::ide0)   0:0x7c00
;--------------------------------------------------------------------------
load_mbr:
                          
  mov     ah,#0x02                ; 0x02 -     
  mov     al,#0x01                ; 0x01 - -  
  mov     bx,#0x7c00              ; es:bx -     
  mov     ch,#0x00                ; 0x00 -   ()
  mov     cl,#0x01                ; 0x1 -   
  mov     dh,#0                   ;   /
  mov     dl,#0x80                ; 0x80 -   (master::ide0)
  int     0x13                    
  jmp     far 0:0x7c00            ;  
  


msg_hello:
  .byte   13,10
  .ascii  "Linux Gazette ...    Linux  !"
  .byte   13,10
  .byte   0

show_str:
  lodsb                           ;    
  cmp     al,#0x00                ;   
  je      end_show_str            ; ,  
                                  ; 
  push    si                      ;  
  mov     bx,#7
  mov     ah,#0x0e
  int     0x10                    ;   

  pop     si                      ;  
  jmp     show_str                ;   
end_show_str:
  ret

